﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using Android.Graphics;
using Java.Util;
using Android.Views;
using System;
using Java.Text;

namespace NaNPointSample
{
    [Activity(Label = "TrackballSample", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
       protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            LinearLayout rootLayout = new LinearLayout(this);
            rootLayout.Orientation = Orientation.Vertical;
            SfChart chart = new SfChart(this);
            chart.SetBackgroundColor(Color.White);

            DateTimeAxis xAxis = new DateTimeAxis();
            chart.PrimaryAxis = xAxis;
            chart.SecondaryAxis = new NumericalAxis();

            ColumnSeries series = new ColumnSeries();
            series.DataSource = GetDateTimeValue();
            chart.Series.Add(series);

            TextView label = new TextView(this);
            label.SetBackgroundColor(Color.White);
            label.SetTextColor(Color.Black);
            chart.Behaviors.Add(new ChartTrackballExt(label));

            rootLayout.AddView(label);
            rootLayout.AddView(chart);
           
            SetContentView(rootLayout);
        }

        public static ObservableArrayList GetDateTimeValue()
        {
            Calendar calendar = new GregorianCalendar(2015, 0, 1);
            ObservableArrayList datas = new ObservableArrayList();
            datas.Add(new ChartDataPoint(calendar.Time, 10d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 31d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 40d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 45d));
            addMonthDate(calendar);
            datas.Add(new ChartDataPoint(calendar.Time, 10d));
            addMonthDate(calendar);
            return datas;
        }

        static void addMonthDate(Calendar calendar)
        {
            calendar.Add(Java.Util.CalendarField.Month, 1);
        }
    }

    public class ChartTrackballExt : ChartTrackballBehavior
    {
        TextView label;
        public ChartTrackballExt(TextView _label)
        {
            label = _label;
        }

        protected override View GetView(ChartSeries p0, ChartDataPoint p1, int p2)
        {
            Date date = p1.GetX() as Date;
            double yValue = Double.Parse(p1.GetY().ToString());
            String formatDate = new SimpleDateFormat("yyyy-MM-dd").Format(date);
            label.Text = "Date: " + formatDate + "\n" + "YValue: " + yValue.ToString();
            return base.GetView(p0, p1, p2);
        }
    }
}

